/*
 *      Program do przegladania logow z ekg.
 *      Rozne komendy.
 *
 *
 *      copyright (c) 2003 by Lukasz Bartnik
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "com_various.hh"
#include "ui.hh"

/*
 * command_quit::run()
 *
 * wywoluje dzialanie dla komendy quit - argumenty nie sa sprawdzane
 */
void command_quit::run(const int, const std::vector<std::string> &argv) {
    throw quit_exception();
}


/*
 * command_help::run()
 *
 * wywoluje dzialanie dla komendy quit - argumenty nie sa sprawdzane
 */
void command_help::run(const int, const std::vector<std::string> &argv) {
    if(!argv.size())
	help_commands(_mw);
    else if(argv.size() == 1) {
	if(argv[0] == "help")
	    help_command_help(_mw);
	else if(argv[0] == "find")
	    help_command_find(_mw);
	else if(argv[0] == "list")
	    help_command_list(_mw);
	else {
	    std::string tmp = "Nie ma dostpnej pomocy dla polecenia: " + argv[0];
	    _mw->print(tmp.c_str(), "\\c010:\\c100:\\c110:\\d ");
	}
    }
    else {
	_mw->print("Zbyt duo argumentw dla komendy help.", "\\c010:\\c100:\\c110:\\d ");
    }

    _mw->show_last();
}


/*
 * command_help::run()
 *
 * wywoluje dzialanie dla komendy quit - argumenty nie sa sprawdzane
 */
void command_list::run(const int, const std::vector<std::string> &argv) {

    if(_list.size() == 0)
	for(int i=0; i<_db->size(); ++i) {
	    l_ent t(_db->get_uinlog(i)->nick(),_db->get_uinlog(i)->uin(),
		    _db->get_uinlog(i)->size(),_db->get_uinlog(i)->_msg_no);
	    _list.push_back(t);
	    _all_chats += _db->get_uinlog(i)->size();
	    _all_msgs += _db->get_uinlog(i)->_msg_no;
	}


    if(argv.size() == 0) {
	_mw->print("Lista posortowana wg. nickw.", "\\c010:\\c200:\\c210:\\d ");
    }
    else if(argv.size() == 1) {
	if(argv[0] == "-n") {
	    _mw->print("Lista posortowana wg. nickw.", "\\c010:\\c200:\\c210:\\d ");
	}
	else if(argv[0] == "-u") {
	    _mw->print("Lista posortowana wg. uinw.", "\\c010:\\c200:\\c210:\\d ");
	    std::sort(_list.begin(),_list.end(),sort_uin());
	}
	else if(argv[0] == "-c") {
	    _mw->print("Lista posortowana wg. iloci chatw.", "\\c010:\\c200:\\c210:\\d ");
	    std::sort(_list.begin(),_list.end(),sort_chat());
	}
	else if(argv[0] == "-m") {
	    _mw->print("Lista posortowana wg. iloci wiadomoci.", "\\c010:\\c200:\\c210:\\d ");
	    std::sort(_list.begin(),_list.end(),sort_msg());
	}
	else if(argv[0] == "-a") {
	    std::string tmp = "Razem chatw: ";
	    tmp += string_cast(_all_chats);
	    tmp += ", wiadomoci: " + string_cast(_all_msgs) + ".";
	    _mw->print(tmp.c_str(), "\\c010:\\c200:\\c210:\\d ");
	    _mw->show_last();
	    return;
	}
	else {
	    std::string tmp = "Nieprawidowy argument dla komendy list: " + argv[0];
	    _mw->print(tmp.c_str(), "\\c010:\\c100:\\c110:\\d ");
	    _mw->show_last();
	    return;
	}
    }
    else {
	_mw->print("Zbyt duo argumentw dla komendy list.", "\\c010:\\c100:\\c110:\\d ");
	_mw->show_last();
	return;
    }

    /* ### wypisanie na ekran ### */
    for(std::vector<l_ent>::iterator i=_list.begin();
	i!=_list.end(); ++i)
    {
	std::string tmp = i->nick;
	tmp += "\\c610/\\d";
	tmp += string_cast(i->uin);

	unsigned int size = 36-tmp.size();
	for(unsigned int j=0; j<size; ++j) tmp+=' ';

	tmp += "chatw: " + string_cast(i->chats);
	tmp += ", wiadomoci: " + string_cast(i->msgs);
	_mw->print(tmp.c_str(), "\\c010:\\c200:\\c210:\\d ");
    }
    if(argv.size() && argv[0] != "-n")
	std::sort(_list.begin(),_list.end(),sort_nick());

    _mw->show_last();
}


