/*
 *      Program do przegladania logow z ekg.
 *      Wyszukiwanie stringa w wiadomosciach.
 *
 *
 *      copyright (c) 2003 by Lukasz Bartnik
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include "find.hh"

#include "ui.hh"


/*
 * command_find::run()
 *
 * wywoluje dzialanie dla komendy quit - argumenty nie sa sprawdzane
 */

command_find::lf command_find::_last_find;


void command_find::run(const std::vector<std::string> &argv) {
    int log=0, chat=0, msg=0;
    if(_db->size() == 0) {
	_mw->print("Baza jest pusta.",
	"\\c010:\\c100:\\c110:\\d ");
	return;
    }

    _db->get_uinlog(_last_find.log)->get_chat(_last_find.chat).get_message(_last_find.msg).highlighted = false;

    /* ### Analiza argumentow komendy. ### */
    if(argv.size() == 0) {
	_mw->print("Sprawd help find.", "\\c010:\\c100:\\c110:\\d ");
	return;
    }
    else if(argv.size() == 1) {
	if(_last_find.str != argv[0]) {
	    _last_find.log = 0;
	    _last_find.chat = 0;
	    _last_find.msg = 0;
	    _last_find.offset = 0;
	    _last_find.str = argv[0];
	}
    }
    else if(argv.size() == 2) {
	if(argv[0] != "-c") {
	    std::string tmp = "Nieznany parametr: " + argv[0];
	    _mw->print(tmp.c_str(), "\\c010:\\c100:\\c110:\\d ");
	    return;
	}
	else {
	    /* moze zdarzyc sie, ze -c bedzie dotyczylo tej samej rozmowy */
	    if(_last_find.log != _ui->_chosen_chat.log ||
	       _last_find.chat != _ui->_chosen_chat.chat ||
	       _last_find.str != argv[1])
	    {
		_last_find.log = _ui->_chosen_chat.log;
		_last_find.chat = _ui->_chosen_chat.chat;
		_last_find.msg = 0;
		_last_find.offset = 0;
		_last_find.str = argv[1];
	    }
	}
    }
    else {
	_mw->print("Dopuszczalne s co najwyej dwa argumenty, z ktrych "
		   "pierwszy to parametr, a drugi to wyszukiwany cig.",
		   "\\c010:\\c100:\\c110:\\d ");
	return;
    }

    /* ### Wlasciwy kod wyszukiwania ### */
    for(log = _last_find.log; log!=_db->size(); ++log) {
	uinlog_t *uinlog = _db->get_uinlog(log);

	for(chat = _last_find.chat; chat!=uinlog->size(); ++chat) {
	    chat_t *chptr = &uinlog->get_chat(chat);

	    for(msg = _last_find.msg; msg!=chptr->size(); ++msg) {
		unsigned int offset =chptr->get_message(msg).str.find(_last_find.str, _last_find.offset);
		if(offset != std::string::npos) {
		    _last_find.offset = offset+1;
		    chptr->get_message(msg).highlighted = true;

		    _last_find.log = log;
		    _last_find.chat = chat;
		    _last_find.msg = msg;
		    goto END;
		}
		_last_find.offset = 0;
	    }
	    _last_find.msg = 0;
	}
	_last_find.chat = 0;
    }

    /* czyscimy zapamietane wspolrzedne, jesli nic nie znalazl */
    _last_find.log = 0;
    _last_find.chat = 0;
    _last_find.msg = 0;
    _last_find.offset = 0;
    _last_find.str = "";

    if(0) {
END:
	std::string tmp = "Znaleziono \"" + _last_find.str;
	tmp += "\": " + _db->get_uinlog(log)->nick();
	tmp += '/' + string_cast(_db->get_uinlog(log)->uin());
	tmp += ", rozmowa " + string_cast(chat+1);
	tmp += ", wiadomo " + string_cast(msg+1);

	_mw->print(tmp.c_str(), "\\c010:\\c400:\\c410:\\d ");
	throw found_string_exception(log,chat,msg);
    }
}
